Unit ASG0C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ASG0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer; P :Integer);

implementation

procedure ASG0C(var A :Array of Complex; var B :Array of Complex;
                var X :Array of Complex; N :Integer; P :Integer);
var
F,L,M,I,J,K :Integer;
S,R,W :Complex;
label
_15,_1,_2,_3,_4,_5,_6,_8,_9,_10;
begin
if ( N > 1 ) 
 then goto _15;
if ( N <= 0 ) 
 then goto _10;
X[N-1] := DivC(B[N-1],A[(N-1)+(N-1)*N]);
goto _10;
_15:
if ( P <> 1 ) 
 then goto _4;

F := 0;
_1:
F := F+1;
S := DivC(Cmplx(1.0,0.E0),A[(F-1)+(F-1)*N]);
L := F+1;
for I:=L to N do
 begin
_2:
  A[(I-1)+(F-1)*N] := SubC(Cmplx(0.0,0.0),MulC(S,A[(I-1)+(F-1)*N]));
 end;
for J:=L to N do
 begin
  for I:=L to N do
   begin
_3:
    A[(I-1)+(J-1)*N] := AddC(A[(I-1)+(J-1)*N],MulC(A[(F-1)+(J-1)*N],A[(I-1)+(F-1)*N]));
   end;
 end;
if ( L-N ) < 0
 then goto _1
 else if ( L-N ) > 0
       then goto _4
       else goto _4;

_4:
for I:=1 to N do
 begin
_5:
  X[I-1] := B[I-1];
 end;
M := N-1;
for J:=1 to M do
 begin
  W := X[J-1];
  K := J+1;
  for I:=K to N do
   begin
_6:
    X[I-1] := AddC(X[I-1],MulC(A[(I-1)+(J-1)*N],W));
   end;
 end;

X[N-1] := DivC(X[N-1],A[(N-1)+(N-1)*N]);
if ( N = 1 ) 
 then goto _10;
K := N;
for I:=1 to M do
 begin
  R := Cmplx(0.0,0.E0);
  L := K-1;
  for J:=K to N do
   begin
_8:
    R := AddC(R,MulC(A[(L-1)+(J-1)*N],X[J-1]));
   end;
  K := N-I;
_9:
  X[K-1] := DivC((SubC(X[K-1],R)),A[(K-1)+(K-1)*N]);
 end;
_10:
end;

end.
